from sqlalchemy.ext.asyncio import AsyncSession
from typing import List
from config.constant import CommonConstant
from exceptions.exception import ServiceException
from module_admin.entity.vo.common_vo import CrudResponseModel
from module_admin.dao.explanation_content_type_dao import Explanation_content_typeDao
from module_admin.entity.vo.explanation_content_type_vo import DeleteExplanation_content_typeModel, Explanation_content_typeModel, Explanation_content_typePageQueryModel
from utils.common_util import CamelCaseUtil
from utils.excel_util import ExcelUtil


class Explanation_content_typeService:
    """
    讲解内容类型模块服务层
    """

    @classmethod
    async def get_explanation_content_type_list_services(
        cls, query_db: AsyncSession, query_object: Explanation_content_typePageQueryModel, is_page: bool = False
    ):
        """
        获取讲解内容类型列表信息service

        :param query_db: orm对象
        :param query_object: 查询参数对象
        :param is_page: 是否开启分页
        :return: 讲解内容类型列表信息对象
        """
        explanation_content_type_list_result = await Explanation_content_typeDao.get_explanation_content_type_list(query_db, query_object, is_page)

        return explanation_content_type_list_result


    @classmethod
    async def add_explanation_content_type_services(cls, query_db: AsyncSession, page_object: Explanation_content_typeModel):
        """
        新增讲解内容类型信息service

        :param query_db: orm对象
        :param page_object: 新增讲解内容类型对象
        :return: 新增讲解内容类型校验结果
        """
        try:
            await Explanation_content_typeDao.add_explanation_content_type_dao(query_db, page_object)
            await query_db.commit()
            return CrudResponseModel(is_success=True, message='新增成功')
        except Exception as e:
            await query_db.rollback()
            raise e

    @classmethod
    async def edit_explanation_content_type_services(cls, query_db: AsyncSession, page_object: Explanation_content_typeModel):
        """
        编辑讲解内容类型信息service

        :param query_db: orm对象
        :param page_object: 编辑讲解内容类型对象
        :return: 编辑讲解内容类型校验结果
        """
        edit_explanation_content_type = page_object.model_dump(exclude_unset=True, exclude={'create_time', 'create_by', })
        explanation_content_type_info = await cls.explanation_content_type_detail_services(query_db, page_object.content_type_id)
        if explanation_content_type_info.content_type_id:
            try:
                await Explanation_content_typeDao.edit_explanation_content_type_dao(query_db, edit_explanation_content_type)
                await query_db.commit()
                return CrudResponseModel(is_success=True, message='更新成功')
            except Exception as e:
                await query_db.rollback()
                raise e
        else:
            raise ServiceException(message='讲解内容类型不存在')

    @classmethod
    async def delete_explanation_content_type_services(cls, query_db: AsyncSession, page_object: DeleteExplanation_content_typeModel):
        """
        删除讲解内容类型信息service

        :param query_db: orm对象
        :param page_object: 删除讲解内容类型对象
        :return: 删除讲解内容类型校验结果
        """
        if page_object.content_type_ids:
            content_type_id_list = page_object.content_type_ids.split(',')
            try:
                for content_type_id in content_type_id_list:
                    await Explanation_content_typeDao.delete_explanation_content_type_dao(query_db, Explanation_content_typeModel(contentTypeId=content_type_id))
                await query_db.commit()
                return CrudResponseModel(is_success=True, message='删除成功')
            except Exception as e:
                await query_db.rollback()
                raise e
        else:
            raise ServiceException(message='传入主键ID为空')

    @classmethod
    async def explanation_content_type_detail_services(cls, query_db: AsyncSession, content_type_id: int):
        """
        获取讲解内容类型详细信息service

        :param query_db: orm对象
        :param content_type_id: 主键ID
        :return: 主键ID对应的信息
        """
        explanation_content_type = await Explanation_content_typeDao.get_explanation_content_type_detail_by_id(query_db, content_type_id=content_type_id)
        if explanation_content_type:
            result = Explanation_content_typeModel(**CamelCaseUtil.transform_result(explanation_content_type))
        else:
            result = Explanation_content_typeModel(**dict())

        return result

    @staticmethod
    async def export_explanation_content_type_list_services(explanation_content_type_list: List):
        """
        导出讲解内容类型信息service

        :param explanation_content_type_list: 讲解内容类型信息列表
        :return: 讲解内容类型信息对应excel的二进制数据
        """
        # 创建一个映射字典，将英文键映射到中文键
        mapping_dict = {
            'contentTypeId': '主键ID',
            'name': '类型名称',
            'typeValue': '类型值',
            'createTime': '创建时间',
            'createBy': '创建者',
            'updateTime': '修改时间',
            'updateBy': '修改者',
        }
        binary_data = ExcelUtil.export_list2excel(explanation_content_type_list, mapping_dict)

        return binary_data
